ForwardingSortedMultiset
Date: 2016-05-24

com.google.common.collect

## Class ForwardingSortedMultiset<E>

- java.lang.Object
- - com.google.common.collect.ForwardingObject
  - - com.google.common.collect.ForwardingCollection<E>
    - - com.google.common.collect.ForwardingMultiset<E>
      - - com.google.common.collect.ForwardingSortedMultiset<E>

- All Implemented Interfaces:
    Multiset<E>, SortedMultiset<E>, java.lang.Iterable<E>, java.util.Collection<E>

      @Beta
      @GwtCompatible(emulated=true)
      public abstract class ForwardingSortedMultiset<E>
      extends ForwardingMultiset<E>
      implements SortedMultiset<E>

  A sorted multiset which forwards all its method calls to another sorted multiset. Subclasses should override one or more methods to modify the behavior of the backing multiset as desired per the decorator pattern.

  Warning: The methods of `ForwardingSortedMultiset` forward indiscriminately to the methods of the delegate. For example, overriding `ForwardingMultiset.add(Object, int)` alone will not change the behavior of `ForwardingCollection.add(Object)`, which can lead to unexpected behavior. In this case, you should override `add(Object)` as well, either providing your own implementation, or delegating to the provided `standardAdd` method.

  The `standard` methods and any collection views they return are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

  Since:
    15.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `ForwardingSortedMultiset.StandardDescendingMultiset` A skeleton implementation of a descending multiset view.
    `protected class` | `ForwardingSortedMultiset.StandardElementSet` A sensible implementation of `SortedMultiset.elementSet()` in terms of the following methods: `Collection.clear()`, `SortedMultiset.comparator()`, `Multiset.contains(java.lang.Object)`, `Multiset.containsAll(java.util.Collection<?>)`, `Multiset.count(java.lang.Object)`, `SortedMultiset.firstEntry()` `SortedMultiset.headMultiset(E, com.google.common.collect.BoundType)`, `Collection.isEmpty()`, `SortedMultiset.lastEntry()`, `SortedMultiset.subMultiset(E, com.google.common.collect.BoundType, E, com.google.common.collect.BoundType)`, `SortedMultiset.tailMultiset(E, com.google.common.collect.BoundType)`, the `size()` and `iterator()` methods of `SortedMultiset.entrySet()`, and `Multiset.remove(Object, int)`.

    - ### Nested classes/interfaces inherited from interface com.google.common.collect.Multiset

      `Multiset.Entry<E>`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ForwardingSortedMultiset()` Constructor for use by subclasses.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Comparator<? super E>` | `comparator()` Returns the comparator that orders this multiset, or `Ordering.natural()` if the natural ordering of the elements is used.
    `protected abstract SortedMultiset<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
    `SortedMultiset<E>` | `descendingMultiset()` Returns a descending view of this multiset.
    `java.util.NavigableSet<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
    `Multiset.Entry<E>` | `firstEntry()` Returns the entry of the first element in this multiset, or `null` if this multiset is empty.
    `SortedMultiset<E>` | `headMultiset(E upperBound, BoundType boundType)` Returns a view of this multiset restricted to the elements less than `upperBound`, optionally including `upperBound` itself.
    `Multiset.Entry<E>` | `lastEntry()` Returns the entry of the last element in this multiset, or `null` if this multiset is empty.
    `Multiset.Entry<E>` | `pollFirstEntry()` Returns and removes the entry associated with the lowest element in this multiset, or returns `null` if this multiset is empty.
    `Multiset.Entry<E>` | `pollLastEntry()` Returns and removes the entry associated with the greatest element in this multiset, or returns `null` if this multiset is empty.
    `protected Multiset.Entry<E>` | `standardFirstEntry()` A sensible definition of `firstEntry()` in terms of `entrySet().iterator()`.
    `protected Multiset.Entry<E>` | `standardLastEntry()` A sensible definition of `lastEntry()` in terms of `descendingMultiset().entrySet().iterator()`.
    `protected Multiset.Entry<E>` | `standardPollFirstEntry()` A sensible definition of `pollFirstEntry()` in terms of `entrySet().iterator()`.
    `protected Multiset.Entry<E>` | `standardPollLastEntry()` A sensible definition of `pollLastEntry()` in terms of `descendingMultiset().entrySet().iterator()`.
    `protected SortedMultiset<E>` | `standardSubMultiset(E lowerBound, BoundType lowerBoundType, E upperBound, BoundType upperBoundType)` A sensible definition of `subMultiset(Object, BoundType, Object, BoundType)` in terms of `headMultiset` and `tailMultiset`.
    `SortedMultiset<E>` | `subMultiset(E lowerBound, BoundType lowerBoundType, E upperBound, BoundType upperBoundType)` Returns a view of this multiset restricted to the range between `lowerBound` and `upperBound`.
    `SortedMultiset<E>` | `tailMultiset(E lowerBound, BoundType boundType)` Returns a view of this multiset restricted to the elements greater than `lowerBound`, optionally including `lowerBound` itself.

    - ### Methods inherited from class com.google.common.collect.ForwardingMultiset

      `add, count, entrySet, equals, hashCode, remove, setCount, setCount, standardAdd, standardAddAll, standardClear, standardContains, standardCount, standardEquals, standardHashCode, standardIterator, standardRemove, standardRemoveAll, standardRetainAll, standardSetCount, standardSetCount, standardSize, standardToString`

    - ### Methods inherited from class com.google.common.collect.ForwardingCollection

      `add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, standardContainsAll, standardIsEmpty, standardToArray, standardToArray, toArray, toArray`

    - ### Methods inherited from class com.google.common.collect.ForwardingObject

      `toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.collect.SortedMultiset

      `entrySet, iterator`

    - ### Methods inherited from interface com.google.common.collect.Multiset

      `add, add, contains, containsAll, count, equals, hashCode, remove, remove, removeAll, retainAll, setCount, setCount, toString`

    - ### Methods inherited from interface java.util.Collection

      `addAll, clear, isEmpty, size, toArray, toArray`

- - ### Constructor Detail

    - #### ForwardingSortedMultiset

          protected ForwardingSortedMultiset()

      Constructor for use by subclasses.

  - ### Method Detail

    - #### delegate

          protected abstract SortedMultiset<E> delegate()

      Description copied from class: `ForwardingObject`
      Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.
      Specified by:
        `delegate` in class `ForwardingMultiset<E>`

    - #### elementSet

          public java.util.NavigableSet<E> elementSet()

      Description copied from interface: `Multiset`
      Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

      If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

      A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

      Specified by:
        `elementSet` in interface `Multiset<E>`
      Specified by:
        `elementSet` in interface `SortedMultiset<E>`
      Overrides:
        `elementSet` in class `ForwardingMultiset<E>`
      Returns:
        a view of the set of distinct elements in this multiset

    - #### comparator

          public java.util.Comparator<? super E> comparator()

      Description copied from interface: `SortedMultiset`
      Returns the comparator that orders this multiset, or `Ordering.natural()` if the natural ordering of the elements is used.
      Specified by:
        `comparator` in interface `SortedMultiset<E>`

    - #### descendingMultiset

          public SortedMultiset<E> descendingMultiset()

      Description copied from interface: `SortedMultiset`
      Returns a descending view of this multiset. Modifications made to either map will be reflected in the other.
      Specified by:
        `descendingMultiset` in interface `SortedMultiset<E>`

    - #### firstEntry

          public Multiset.Entry<E> firstEntry()

      Description copied from interface: `SortedMultiset`
      Returns the entry of the first element in this multiset, or `null` if this multiset is empty.
      Specified by:
        `firstEntry` in interface `SortedMultiset<E>`

    - #### standardFirstEntry

          protected Multiset.Entry<E> standardFirstEntry()

      A sensible definition of `firstEntry()` in terms of `entrySet().iterator()`. If you override `ForwardingMultiset.entrySet()`, you may wish to override `firstEntry()` to forward to this implementation.

    - #### lastEntry

          public Multiset.Entry<E> lastEntry()

      Description copied from interface: `SortedMultiset`
      Returns the entry of the last element in this multiset, or `null` if this multiset is empty.
      Specified by:
        `lastEntry` in interface `SortedMultiset<E>`

    - #### standardLastEntry

          protected Multiset.Entry<E> standardLastEntry()

      A sensible definition of `lastEntry()` in terms of `descendingMultiset().entrySet().iterator()`. If you override `descendingMultiset()` or `ForwardingMultiset.entrySet()`, you may wish to override `firstEntry()` to forward to this implementation.

    - #### pollFirstEntry

          public Multiset.Entry<E> pollFirstEntry()

      Description copied from interface: `SortedMultiset`
      Returns and removes the entry associated with the lowest element in this multiset, or returns `null` if this multiset is empty.
      Specified by:
        `pollFirstEntry` in interface `SortedMultiset<E>`

    - #### standardPollFirstEntry

          protected Multiset.Entry<E> standardPollFirstEntry()

      A sensible definition of `pollFirstEntry()` in terms of `entrySet().iterator()`. If you override `ForwardingMultiset.entrySet()`, you may wish to override `pollFirstEntry()` to forward to this implementation.

    - #### pollLastEntry

          public Multiset.Entry<E> pollLastEntry()

      Description copied from interface: `SortedMultiset`
      Returns and removes the entry associated with the greatest element in this multiset, or returns `null` if this multiset is empty.
      Specified by:
        `pollLastEntry` in interface `SortedMultiset<E>`

    - #### standardPollLastEntry

          protected Multiset.Entry<E> standardPollLastEntry()

      A sensible definition of `pollLastEntry()` in terms of `descendingMultiset().entrySet().iterator()`. If you override `descendingMultiset()` or `ForwardingMultiset.entrySet()`, you may wish to override `pollLastEntry()` to forward to this implementation.

    - #### headMultiset

          public SortedMultiset<E> headMultiset(E upperBound,
                                       BoundType boundType)

      Description copied from interface: `SortedMultiset`
      Returns a view of this multiset restricted to the elements less than `upperBound`, optionally including `upperBound` itself. The returned multiset is a view of this multiset, so changes to one will be reflected in the other. The returned multiset supports all operations that this multiset supports.

      The returned multiset will throw an `IllegalArgumentException` on attempts to add elements outside its range.

      Specified by:
        `headMultiset` in interface `SortedMultiset<E>`

    - #### subMultiset

          public SortedMultiset<E> subMultiset(E lowerBound,
                                      BoundType lowerBoundType,
                                      E upperBound,
                                      BoundType upperBoundType)

      Description copied from interface: `SortedMultiset`
      Returns a view of this multiset restricted to the range between `lowerBound` and `upperBound`. The returned multiset is a view of this multiset, so changes to one will be reflected in the other. The returned multiset supports all operations that this multiset supports.

      The returned multiset will throw an `IllegalArgumentException` on attempts to add elements outside its range.

      This method is equivalent to `tailMultiset(lowerBound, lowerBoundType).headMultiset(upperBound, upperBoundType)`.

      Specified by:
        `subMultiset` in interface `SortedMultiset<E>`

    - #### standardSubMultiset

          protected SortedMultiset<E> standardSubMultiset(E lowerBound,
                                              BoundType lowerBoundType,
                                              E upperBound,
                                              BoundType upperBoundType)

      A sensible definition of `subMultiset(Object, BoundType, Object, BoundType)` in terms of `headMultiset` and `tailMultiset`. If you override either of these methods, you may wish to override `subMultiset(Object, BoundType, Object, BoundType)` to forward to this implementation.

    - #### tailMultiset

          public SortedMultiset<E> tailMultiset(E lowerBound,
                                       BoundType boundType)

      Description copied from interface: `SortedMultiset`
      Returns a view of this multiset restricted to the elements greater than `lowerBound`, optionally including `lowerBound` itself. The returned multiset is a view of this multiset, so changes to one will be reflected in the other. The returned multiset supports all operations that this multiset supports.

      The returned multiset will throw an `IllegalArgumentException` on attempts to add elements outside its range.

      Specified by:
        `tailMultiset` in interface `SortedMultiset<E>`